package Tetris;


import java.sql.Connection;
import java.sql.Date;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

// Beispiel aus https://javabeginners.de/Datenbanken/SQLite-Datenbank.php , sieh unten
class PlayerDBController {

        private static final PlayerDBController dbcontroller = new PlayerDBController();
        private static Connection connection;
        private static final String DB_PATH = "userhighscore.db";

        static {
            try {
                Class.forName("org.sqlite.JDBC");
            } catch (ClassNotFoundException e) {
                System.err.println("Fehler beim Laden des JDBC-Treibers");
                e.printStackTrace();
            }
        }

        private PlayerDBController(){
        }

        public static PlayerDBController getInstance(){
            return dbcontroller;
        }

        //Datenbankverbindung herstellen

        public void initDBConnection() {
            try {
                if (connection != null)
                    return;
                System.out.println("Creating Connection to Database...");
                connection = DriverManager.getConnection("jdbc:sqlite:" + DB_PATH);
                if (!connection.isClosed())
                    System.out.println("...Connection established");
            } catch (SQLException e) {
                throw new RuntimeException(e);
            }

            Runtime.getRuntime().addShutdownHook(new Thread() {
                public void run() {
                    try {
                        if (!connection.isClosed() && connection != null) {
                            connection.close();
                            if (connection.isClosed())
                                System.out.println("Connection to Database closed");
                        }
                    } catch (SQLException e) {
                        e.printStackTrace();
                    }
                }
            });
        }

        // Es wird eingegebenen Spielername,Score mit 0 in der Datenbank mit insert gespeichert.
        public void speichereSpieler(Player player) {
            try {
                Statement statement = connection.createStatement();
                statement.setQueryTimeout(30);
                // Spielername gibt es noch garnicht
                ResultSet resultSet = statement.executeQuery("select * from userscore where name='"+player.getName()+"'");
                if(!resultSet.next()){
                    statement.executeUpdate("insert into userscore values('"+player.getName()+"',"+player.getScore()+")");
                }
                else{
                    // Spielername gibt es schon, update player.score wenn größer als score im Datenbank.
                    String query = "UPDATE userscore SET score='"+ player.getScore() +"' WHERE name='"+player.getName()+"'";
                    statement.executeUpdate(query);
                }
            } catch (SQLException e) {
                System.err.println("Couldn't handle DB-Query");
                e.printStackTrace();
            }

        }

        // SpielerDaten aus Datenbank holen, dann in einer Arraylist speicher und zurückgeben.
    public List<Player> holeSpielerDaten() {
        List<Player> playerList = new ArrayList<Player>();
        try {
            Statement statement = connection.createStatement();
            statement.setQueryTimeout(30);
//          statement.executeUpdate("create table userscore (name string, score integer)");
//          statement.executeUpdate("insert into userscore values('leo', 123)");
//          statement.executeUpdate("insert into userscore values('yui', 456)");
            System.out.println("vorRS");

            ResultSet resultSet = statement.executeQuery("SELECT * FROM userscore;");
            System.out.println("nachRS");
            while(resultSet.next())
            {
                playerList.add(new Player(resultSet.getString("name"), resultSet.getInt("score")));

                // Playername gibt es noch nicht in der Datenbank also anlegen.
                // Es fehlt noch der score.
                //statement.executeUpdate("insert into userscore values(1," + playername + ", 123)");
            }
            resultSet.close();

        } catch (SQLException e) {
            System.err.println("Couldn't handle DB-Query");
            e.printStackTrace();
        }
        return playerList;

    }

        private void handleDB() {
            try {
                Statement stmt = connection.createStatement();
                stmt.executeUpdate("DROP TABLE IF EXISTS books;");
                stmt.executeUpdate("CREATE TABLE books (author, title, publication, pages, price);");
                stmt.execute("INSERT INTO books (author, title, publication, pages, price) VALUES ('Paulchen Paule', 'Paul der Penner', '2001-05-06', '1234', '5.67')");

                PreparedStatement ps = connection
                        .prepareStatement("INSERT INTO books VALUES (?, ?, ?, ?, ?);");

                ps.setString(1, "Willi Winzig");
                ps.setString(2, "Willi's Wille");
                ps.setDate(3, Date.valueOf("2011-05-16"));
                ps.setInt(4, 432);
                ps.setDouble(5, 32.95);
                ps.addBatch();

                ps.setString(1, "Anton Antonius");
                ps.setString(2, "Anton's Alarm");
                ps.setDate(3, Date.valueOf("2009-10-01"));
                ps.setInt(4, 123);
                ps.setDouble(5, 98.76);
                ps.addBatch();

                connection.setAutoCommit(false);
                ps.executeBatch();
                connection.setAutoCommit(true);

                ResultSet rs = stmt.executeQuery("SELECT * FROM books;");
                while (rs.next()) {
                    System.out.println("Autor = " + rs.getString("author"));
                    System.out.println("Titel = " + rs.getString("title"));
                    System.out.println("Erscheinungsdatum = "
                            + rs.getDate("publication"));
                    System.out.println("Seiten = " + rs.getInt("pages"));
                    System.out.println("Preis = " + rs.getDouble("price"));
                }
                rs.close();
                connection.close();
            } catch (SQLException e) {
                System.err.println("Couldn't handle DB-Query");
                e.printStackTrace();
            }
        }

//        public static void main(String[] args) {
//            PlayerDBController dbc = PlayerDBController.getInstance();
//            dbc.initDBConnection();
//            dbc.handleDB();
//        }
    }

