package Tetris;

import java.awt.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Stein {
    //SteineTyp Block;
   private int x = 4, y = 0;
    private int normal = 850;
    private int fast = 50;
   // private int rotation;
    private long beginTime;
    private int delayTime = normal;
    private int deltax = 0;
    private boolean collision = false;
   // private int size;

    public static final int BOARD_WIDTH = 11;
    public static final int BOARD_HEIGHT = 20;
    public static final int BLOCK_SIZE = 30;

    private int[][] coords;
    private Board board;
    private Color color;

    public Stein(int[][] coords,Board board,Color color) {
        this.coords = coords;
        this.board = board;
        this.color = color;
    }


    public void setX(int x) {
        this.x = x;
    }

    public void setY(int y) {
        this.y = y;
    }

    public void reset() {
        this.x = 2;
        this.y = 0;
        collision = false;
    }

    //Kollisons abfrage
    public void update() {
        if (collision) {
            for (int row = 0; row < coords.length; row++) {
                for (int col = 0; col < coords[0].length; col++) {
                    if (coords[row][col] != 0) {
                        board.getBoard()[y + row][x + col] = color;
                    }
                }
            }
            linieLöschen();
            board.setCurrenStein();
            return;
        }

        boolean moveX=true;
        if (!(x + deltax + coords[0].length > 11) && !(x + deltax < 0)) {
            for (int row = 0; row < coords.length; row++) {
                for (int col = 0; col < coords[row].length; col++) {
                    if(coords[row][col] !=0) {
                        if (board.getBoard()[y + row][x + deltax + col] != null) {
                            moveX = true;
                        }
                    }
                }
            }
            if(moveX){
                x += deltax;
            }

        }

        deltax = 0;
// stapeln
        if (System.currentTimeMillis() - beginTime > delayTime) {
            if (!(y + 1+coords.length > BOARD_HEIGHT)) {
                for (int row = 0; row < coords.length; row++) {
                    for (int col = 0; col < coords[row].length; col++) {
                        if (coords[row][col] != 0){

                            if (board.getBoard()[y +1 + row][x - deltax + col] != null) {
                                collision = true;
                            }
                    }
                }
            }
                if (!collision) {
                y++;
                }
            }
            else {
                collision = true;
            }

        beginTime = System.currentTimeMillis();
    }

}

public void linieLöschen(){
        int bollomLine = board.getBoard().length - 1;
        for(int topLine =  board.getBoard().length - 1; topLine > 0; topLine--){
             int anZahl = 0;
             for(int col = 0; col < board.getBoard()[0].length; col++){
                 if(board.getBoard()[topLine][col] != null) {
                     anZahl++;
                 }
                 board.getBoard()[bollomLine][col] = board.getBoard()[topLine][col];
             }
             if(anZahl < board.getBoard()[0].length){
                 bollomLine--;
             }
        }
}

public void render(Graphics g){
    for(int row=0;row< coords.length;row++){
        for(int col = 0;col< coords[0].length;col++){
            if(coords[row][col] !=0){
                g.setColor(color);
                //
                g.fillRect(col*BLOCK_SIZE+x*BLOCK_SIZE,row*BLOCK_SIZE+y*BLOCK_SIZE,BLOCK_SIZE,BLOCK_SIZE);
            }
        }
    }
}
/*Kerbs Ewen
Hier wird der stein rotiert dazu wurden die hilfs methoden : datenarrayflippen, steineflippen implementiert
diese helfen das komplexe steinrotiert verständlich zu machen.
Beim datenarrayflippen wird einmal das neue array ausgerechnet wie es auszusehen hat.
Da aber die bei dieser formatierung das array falsch herum aufgebaut wird benötigt man die hilfsmethode steineflippen
Diese dreht dreht das array um sodas der stein richtig gezeigt werden kann

* */
    public void steinRotiert()
    {
        int[][] rotierterstein = null;
        rotierterstein = datenarrayflippen(coords);
        rotierterstein = steineflippen(rotierterstein);
        coords = rotierterstein;
    }

    private int[][] datenarrayflippen(int[][] altesArray)
    {
        int[][] updatedArray = new int[altesArray[0].length][altesArray.length];
        for (int i = 0; i < altesArray.length; i++) {
            for (int j = 0; j < altesArray[0].length; j++) {
                updatedArray[j][i] = altesArray[i][j];
            }
        }
        return updatedArray;

    }

    private int[][] steineflippen(int[][] rotierenedesArray)
    {
        int mittelpunkt = rotierenedesArray.length / 2;
        for (int i = 0; i < mittelpunkt; i++) {
            int[] rotiertesArray = rotierenedesArray[i];
            rotierenedesArray[i] = rotierenedesArray[rotierenedesArray.length - i - 1];
            rotierenedesArray[rotierenedesArray.length - i - 1] = rotiertesArray;
        }
        return rotierenedesArray;

    }


    public void speedup(){
    delayTime=fast;
}
public void speedDown(){
    delayTime=normal;
}
public void moveRight(){
    deltax = 1;
    }
    public void moveLeft(){
        deltax = -1;
    }
}
